/*
   This is a part of the Niver's Settings IPC LiteStep Module Source code.

   Copyright (C) 2003 Niversoft 
   http//niversoft.dyndns.org
   info@niversoft.dyndns.org

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

//-------------------------------------------------------------------------------------

#include "settingsipc_svr.h"
#include "settingsipcdefs.h"

settingsipc_svr *module = NULL; // The module

#include <stdio.h> 
#include <stdlib.h> 
#include <string.h> 
#include <windows.h> 
 
int initModuleEx(HWND parentWnd, HINSTANCE dllInst, LPCSTR szPath)
{
	int code;
	if (!module) module = new settingsipc_svr(dllInst, code);  	
   return code;
}

void quitModule(HINSTANCE dllInst)
{
	delete module;
   module = NULL;
}

settingsipc_svr::settingsipc_svr(HINSTANCE dllInst, int& code)
{
   code = 1;
   
   if (!GetLitestepWnd()) return;
   
   DWORD ThreadID;

   hMap  = CreateFileMapping(INVALID_HANDLE_VALUE, NULL, PAGE_READWRITE, 0, sizeof(TSharedMemory), SHAREDMEMNAME);
   hExec = CreateEvent(NULL, FALSE, FALSE, EVENT_EXEC);
   hDone = CreateEvent(NULL, FALSE, FALSE, EVENT_DONE);
   pMsg  = (TSharedMemory *)MapViewOfFile(hMap, FILE_MAP_WRITE, 0, 0, sizeof(TSharedMemory));

   m_Thread = CreateThread(NULL, 0, MainThreadProc, NULL, 0, &ThreadID);
   
	code = 0;
}

settingsipc_svr::~settingsipc_svr()
{
   TerminateThread(m_Thread, 0);	
   
   CloseHandle(hExec);
   CloseHandle(hDone);         
   UnmapViewOfFile(pMsg);
   CloseHandle(hMap);   
}


DWORD WINAPI settingsipc_svr::MainThreadProc(LPVOID lpParameter) // static member
{
   if (module) return module->MainThreadProc();
   return 0;   
}

DWORD settingsipc_svr::MainThreadProc()
{
   while (1)
   {
      WaitForSingleObject(hExec, INFINITE);

      switch(module->pMsg->Action)
      {
      case eaNoAction:
         break;
      case eaGetLitestepWnd:
         module->pMsg->hWnd = GetLitestepWnd();
         break;
      case eaGetRCInt:
         module->pMsg->nRetValue = GetRCInt(module->pMsg->szKeyName, pMsg->nDefaultValue); 
         break;
      case eaGetRCBool:
         pMsg->nRetValue = GetRCBool(pMsg->szKeyName, pMsg->nDefaultValue);
         break;
      case eaGetRCBoolDef:
         pMsg->nRetValue = GetRCBoolDef(pMsg->szKeyName, pMsg->nDefaultValue);
         break;
      case eaGetRCColor:
         pMsg->nRetValue = GetRCColor(pMsg->szKeyName, pMsg->nDefaultValue);
         break;
      case eaGetRCString:
         pMsg->nRetValue = GetRCString(pMsg->szKeyName, pMsg->szRetValue, pMsg->szDefaultValue, pMsg->nMaxLength);
         break;
      case eaGetRCLine:
         pMsg->nRetValue = GetRCLine(pMsg->szKeyName, pMsg->szRetValue, pMsg->nMaxLength, pMsg->szDefaultValue);
         break;
      }
      SetEvent(hDone);
   }
}
